## bup 0.14a

=== Makefile ===
OS:=$(shell uname | sed 's/[-_].*//')
CFLAGS=-Wall -g -O2 -Werror $(PYINCLUDE) -g
ifneq ($(OS),CYGWIN)
  CFLAGS += -fPIC
endif
SHARED=-shared
SOEXT:=.so

ifeq (${OS},Darwin)
  MACHINE:=$(shell arch)
  CFLAGS += -arch $(MACHINE)
  SHARED = -dynamiclib
endif
ifeq ($(OS),CYGWIN)
  LDFLAGS += -L/usr/bin
  EXT:=.exe
  SOEXT:=.dll
endif

default: all

all: bup Documentation/all

bup: lib/bup/_version.py lib/bup/_hashsplit$(SOEXT) cmds

Documentation/all: bup

INSTALL=install
MANDIR=$(DESTDIR)/usr/share/man
DOCDIR=$(DESTDIR)/usr/share/doc/bup
BINDIR=$(DESTDIR)/usr/bin
LIBDIR=$(DESTDIR)/usr/lib/bup
install: all
	$(INSTALL) -d $(MANDIR)/man1 $(DOCDIR) $(BINDIR) \
		$(LIBDIR)/bup $(LIBDIR)/cmd
	$(INSTALL) -o 0 -g 0 -m 0644 \
		$(wildcard Documentation/*.1) \
		$(MANDIR)/man1
	$(INSTALL) -o 0 -g 0 -m 0644 \
		$(wildcard Documentation/*.html) \
		$(DOCDIR)
	$(INSTALL) -o 0 -g 0 -m 0755 bup $(BINDIR)
	$(INSTALL) -o 0 -g 0 -m 0755 \
		$(wildcard cmd/bup-*) \
		$(LIBDIR)/cmd
	$(INSTALL) -o 0 -g 0 -m 0644 \
		$(wildcard lib/bup/*.so lib/bup/*.py) \
		$(LIBDIR)/bup
	
%/all:
	$(MAKE) -C $* all
	
%/clean:
	$(MAKE) -C $* clean

lib/bup/_hashsplit$(SOEXT): lib/bup/_hashsplit.c lib/bup/csetup.py
	@rm -f $@
	cd lib/bup && python csetup.py build
	cp lib/bup/build/*/_hashsplit$(SOEXT) lib/bup/

.PHONY: lib/bup/_version.py
lib/bup/_version.py:
	rm -f $@ $@.new
	./format-subst.pl $@.pre >$@.new
	mv $@.new $@
	
runtests: all runtests-python runtests-cmdline

runtests-python:
	./wvtest.py $(wildcard t/t*.py)
	
runtests-cmdline: all
	t/test.sh
	
stupid:
	PATH=/bin:/usr/bin $(MAKE) test
	
test: all
	./wvtestrun $(MAKE) runtests

%: %.o
	$(CC) $(CFLAGS) (LDFLAGS) -o $@ $^ $(LIBS)
	
bup: main.py
	rm -f $@
	ln -s $< $@
	
cmds: $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py))

cmd/bup-%: cmd/%-cmd.py
	rm -f $@
	ln -s $*-cmd.py $@
	
%: %.py
	rm -f $@
	ln -s $< $@
	
bup-%: cmd-%.sh
	rm -f $@
	ln -s $< $@
	
%.o: %.c
	gcc -c -o $@ $< $(CPPFLAGS) $(CFLAGS)

clean: Documentation/clean
	rm -f *.o *.so */*/*.so *.dll *.exe .*~ *~ */*~ */*/*~ \
		*.pyc */*.pyc */*/*.pyc \
		bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
		out[12] out2[tc] tags[12] tags2[tc]
	rm -rf *.tmp build lib/bup/build

=== Documentation/Makefile ===
PANDOC:=$(shell \
	if pandoc </dev/null 2>/dev/null; then \
		echo pandoc; \
	else \
		echo "Warning: pandoc not installed; can't generate manpages." >&2; \
		echo '@echo Skipping: pandoc'; \
	fi)
BUP_VERSION:=$(shell ../bup version --tag)
BUP_DATE:=$(shell ../bup version --date)

default: all

all: man html

man: $(patsubst %.md,%,$(wildcard *.md))

html: $(patsubst %.1.md,%.html,$(wildcard *.md))

%: %.md.tmp Makefile
	$(PANDOC) -s -r markdown -w man -o $@ $<
	
%.html: %.1.md.tmp Makefile
	$(PANDOC) -s -r markdown -w html -o $@ $<
	
.PRECIOUS: %.md.tmp
%.md.tmp: %.md Makefile
	rm -f $@ $@.new
	sed -e 's,%BUP_VERSION%,${BUP_VERSION},g' \
	    -e 's,%BUP_DATE%,${BUP_DATE},g' <$< >$@.new
	mv $@.new $@

clean:
	rm -f *~ .*~ *.[0-9] *.new *.tmp *.html

=== debian/changelog ===
bup (0.14a-2) unstable; urgency=low

  * Add git to Build-Depends. Thanks Laurent Fousse. Closes: #584248

 -- Jon Dowland <jmtd@debian.org>  Wed, 02 Jun 2010 22:40:49 +0100

bup (0.14a-1) unstable; urgency=low

  * Initial release. Closes: #564600

 -- Jon Dowland <jmtd@debian.org>  Thu, 01 Apr 2010 10:05:55 +0100

=== debian/control ===
Source: bup
Section: admin
Priority: extra
Maintainer: Jon Dowland <jmtd@debian.org>
Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev,
 git (>= 1:1.7.0.4-2) | git-core
Standards-Version: 3.8.4
Homepage: http://github.com/apenwarr/bup

Package: bup
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 python, git (>= 1:1.7.0.4-2) | git-core, python-fuse
Recommends: par2
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

## bup 0.17b

=== Makefile ===
OS:=$(shell uname | sed 's/[-_].*//')
CFLAGS=-Wall -g -O2 -Werror $(PYINCLUDE) -g
ifneq ($(OS),CYGWIN)
  CFLAGS += -fPIC
endif
SHARED=-shared
SOEXT:=.so

ifeq (${OS},Darwin)
  MACHINE:=$(shell arch)
  CFLAGS += -arch $(MACHINE)
  SHARED = -dynamiclib
endif
ifeq ($(OS),CYGWIN)
  LDFLAGS += -L/usr/bin
  EXT:=.exe
  SOEXT:=.dll
endif

default: all

all: bup Documentation/all

bup: lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds

Documentation/all: bup

INSTALL=install
PYTHON=python
MANDIR=$(DESTDIR)/usr/share/man
DOCDIR=$(DESTDIR)/usr/share/doc/bup
BINDIR=$(DESTDIR)/usr/bin
LIBDIR=$(DESTDIR)/usr/lib/bup
install: all
	$(INSTALL) -d $(MANDIR)/man1 $(DOCDIR) $(BINDIR) \
		$(LIBDIR)/bup $(LIBDIR)/cmd $(LIBDIR)/tornado \
		$(LIBDIR)/web
	[ ! -e Documentation/.docs-available ] || \
	  $(INSTALL) -m 0644 \
		Documentation/*.1 \
		$(MANDIR)/man1
	[ ! -e Documentation/.docs-available ] || \
	  $(INSTALL) -m 0644 \
		Documentation/*.html \
		$(DOCDIR)
	$(INSTALL) -m 0755 bup $(BINDIR)
	$(INSTALL) -m 0755 \
		cmd/bup-* \
		$(LIBDIR)/cmd
	$(INSTALL) -m 0644 \
		lib/bup/*.py \
		$(LIBDIR)/bup
	$(INSTALL) -m 0755 \
		lib/bup/*$(SOEXT) \
		$(LIBDIR)/bup
	$(INSTALL) -m 0644 \
		lib/tornado/*.py \
		$(LIBDIR)/tornado
	$(INSTALL) -m 0644 \
		lib/web/* \
		$(LIBDIR)/web
%/all:
	$(MAKE) -C $* all

%/clean:
	$(MAKE) -C $* clean

lib/bup/_helpers$(SOEXT): \
		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
	@rm -f $@
	cd lib/bup && $(PYTHON) csetup.py build
	cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/

.PHONY: lib/bup/_version.py
lib/bup/_version.py:
	rm -f $@ $@.new
	./format-subst.pl $@.pre >$@.new
	mv $@.new $@

runtests: all runtests-python runtests-cmdline

runtests-python:
	$(PYTHON) wvtest.py $(wildcard t/t*.py lib/*/t/t*.py)

runtests-cmdline: all
	t/test.sh

stupid:
	PATH=/bin:/usr/bin $(MAKE) test

test: all
	./wvtestrun $(MAKE) PYTHON=$(PYTHON) runtests

check: test

%: %.o
	$(CC) $(CFLAGS) (LDFLAGS) -o $@ $^ $(LIBS)

bup: main.py
	rm -f $@
	ln -s $< $@

cmds: $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py))

cmd/bup-%: cmd/%-cmd.py
	rm -f $@
	ln -s $*-cmd.py $@

%: %.py
	rm -f $@
	ln -s $< $@

bup-%: cmd-%.sh
	rm -f $@
	ln -s $< $@

%.o: %.c
	gcc -c -o $@ $< $(CPPFLAGS) $(CFLAGS)

clean: Documentation/clean
	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll *.exe \
		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
		bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
		out[12] out2[tc] tags[12] tags2[tc]
	rm -rf *.tmp t/*.tmp lib/*/*/*.tmp build lib/bup/build

=== Documentation/Makefile ===
--- 
+++ 
@@ -1,9 +1,11 @@
 PANDOC:=$(shell \
 	if pandoc </dev/null 2>/dev/null; then \
 		echo pandoc; \
+		touch .docs-available; \
 	else \
 		echo "Warning: pandoc not installed; can't generate manpages." >&2; \
 		echo '@echo Skipping: pandoc'; \
+		rm -f .docs-available; \
 	fi)
 BUP_VERSION:=$(shell ../bup version --tag)
 BUP_DATE:=$(shell ../bup version --date)
@@ -30,4 +32,4 @@
 	mv $@.new $@
 
 clean:
-	rm -f *~ .*~ *.[0-9] *.new *.tmp *.html
+	rm -f *~ .*~ *.[0-9] *.new *.tmp *.html .docs-available

=== debian/changelog ===
bup (0.17b-2squeeze1) testing-proposed-updates; urgency=low

  * use python-support to tightly version python dependency,
    needed due to the binary extensions. Thanks Jakub Wilk.
    Closes: #608568.

 -- Jon Dowland <jmtd@debian.org>  Mon, 03 Jan 2011 10:31:55 +0000

bup (0.17b-2) unstable; urgency=low

  * add git as a build dependency. Closes: #595949
  * bump standards version.

 -- Jon Dowland <jmtd@debian.org>  Tue, 07 Sep 2010 22:08:48 +0100

bup (0.17b-1) unstable; urgency=low

  * New upstream version.
  * document package VCS in control file

 -- Jon Dowland <jmtd@debian.org>  Tue, 07 Sep 2010 17:03:28 +0100

## bup 0.20

=== Makefile ===
--- 
+++ 
@@ -34,7 +34,7 @@
 install: all
 	$(INSTALL) -d $(MANDIR)/man1 $(DOCDIR) $(BINDIR) \
 		$(LIBDIR)/bup $(LIBDIR)/cmd $(LIBDIR)/tornado \
-		$(LIBDIR)/web
+		$(LIBDIR)/web $(LIBDIR)/web/static
 	[ ! -e Documentation/.docs-available ] || \
 	  $(INSTALL) -m 0644 \
 		Documentation/*.1 \
@@ -57,8 +57,11 @@
 		lib/tornado/*.py \
 		$(LIBDIR)/tornado
 	$(INSTALL) -m 0644 \
-		lib/web/* \
-		$(LIBDIR)/web
+		lib/web/static/* \
+		$(LIBDIR)/web/static/
+	$(INSTALL) -m 0644 \
+		lib/web/*.html \
+		$(LIBDIR)/web/
 %/all:
 	$(MAKE) -C $* all
 
@@ -116,6 +119,35 @@
 
 %.o: %.c
 	gcc -c -o $@ $< $(CPPFLAGS) $(CFLAGS)
+	
+# update the local 'man' and 'html' branches with pregenerated output files, for
+# people who don't have pandoc (and maybe to aid in google searches or something)
+export-docs: Documentation/all
+	git update-ref refs/heads/man origin/man '' 2>/dev/null || true
+	git update-ref refs/heads/html origin/html '' 2>/dev/null || true
+	GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
+	rm -f $${GIT_INDEX_FILE} && \
+	git add -f Documentation/*.1 && \
+	git update-ref refs/heads/man \
+		$$(echo "Autogenerated man pages for $$(git describe)" \
+		    | git commit-tree $$(git write-tree --prefix=Documentation) \
+				-p refs/heads/man) && \
+	rm -f $${GIT_INDEX_FILE} && \
+	git add -f Documentation/*.html && \
+	git update-ref refs/heads/html \
+		$$(echo "Autogenerated html pages for $$(git describe)" \
+		    | git commit-tree $$(git write-tree --prefix=Documentation) \
+				-p refs/heads/html)
+
+# push the pregenerated doc files to origin/man and origin/html
+push-docs: export-docs
+	git push origin man html
+
+# import pregenerated doc files from origin/man and origin/html, in case you
+# don't have pandoc but still want to be able to install the docs.
+import-docs: Documentation/clean
+	git archive origin/html | (cd Documentation; tar -xvf -)
+	git archive origin/man | (cd Documentation; tar -xvf -)
 
 clean: Documentation/clean
 	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll *.exe \

=== debian/changelog ===
bup (0.20-1) unstable; urgency=low

  * new upstream version.

 -- Jon Dowland <jmtd@debian.org>  Fri, 17 Dec 2010 23:52:43 +0000

=== debian/control ===
Source: bup
Section: admin
Priority: extra
Maintainer: Jon Dowland <jmtd@debian.org>
Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev,
 git (>= 1:1.7.0.4-2) | git-core
Standards-Version: 3.9.1
Homepage: http://github.com/apenwarr/bup
Vcs-Git: git://git.debian.org/collab-maint/bup.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/bup.git;a=shortlog;h=refs/heads/debian

Package: bup
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 python, git (>= 1:1.7.0.4-2) | git-core, python-fuse,
 python-tornado (>= 1.0.1-1)
Recommends: par2
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

## bup 0.22a

=== Makefile ===
--- 
+++ 
@@ -83,7 +83,7 @@
 runtests: all runtests-python runtests-cmdline
 
 runtests-python:
-	$(PYTHON) wvtest.py $(wildcard t/t*.py lib/*/t/t*.py)
+	$(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py
 
 runtests-cmdline: all
 	t/test.sh
@@ -103,7 +103,9 @@
 	rm -f $@
 	ln -s $< $@
 
-cmds: $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py))
+cmds: \
+    $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
+    $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
 
 cmd/bup-%: cmd/%-cmd.py
 	rm -f $@
@@ -116,6 +118,10 @@
 bup-%: cmd-%.sh
 	rm -f $@
 	ln -s $< $@
+
+cmd/bup-%: cmd/%-cmd.sh
+	rm -f $@
+	ln -s $*-cmd.sh $@
 
 %.o: %.c
 	gcc -c -o $@ $< $(CPPFLAGS) $(CFLAGS)

=== debian/changelog ===
bup (0.22a-1) unstable; urgency=low

  * New upstream version. Closes: #610690.

 -- Jon Dowland <jmtd@debian.org>  Mon, 07 Feb 2011 22:40:44 +0000

bup (0.20-2) unstable; urgency=low

  * use python-support to tightly version python dependency,
    needed due to the binary extensions. Thanks Jakub Wilk.
    Closes: #608568.

 -- Jon Dowland <jmtd@debian.org>  Sun, 02 Jan 2011 20:17:40 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: extra
 Maintainer: Jon Dowland <jmtd@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev,
+Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev, python-support,
  git (>= 1:1.7.0.4-2) | git-core
 Standards-Version: 3.9.1
 Homepage: http://github.com/apenwarr/bup
@@ -11,7 +11,7 @@
 
 Package: bup
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends},
+Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends},
  python, git (>= 1:1.7.0.4-2) | git-core, python-fuse,
  python-tornado (>= 1.0.1-1)
 Recommends: par2

## bup 0.24b

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,8 @@
 OS:=$(shell uname | sed 's/[-_].*//')
-CFLAGS=-Wall -g -O2 -Werror $(PYINCLUDE) -g
-ifneq ($(OS),CYGWIN)
-  CFLAGS += -fPIC
-endif
-SHARED=-shared
+CFLAGS:=-Wall -O2 -Werror $(PYINCLUDE)
 SOEXT:=.so
 
-ifeq (${OS},Darwin)
-  MACHINE:=$(shell arch)
-  CFLAGS += -arch $(MACHINE)
-  SHARED = -dynamiclib
-endif
 ifeq ($(OS),CYGWIN)
-  LDFLAGS += -L/usr/bin
-  EXT:=.exe
   SOEXT:=.dll
 endif
 
@@ -71,7 +60,7 @@
 lib/bup/_helpers$(SOEXT): \
 		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
 	@rm -f $@
-	cd lib/bup && $(PYTHON) csetup.py build
+	cd lib/bup && LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(PYTHON) csetup.py build
 	cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/
 
 .PHONY: lib/bup/_version.py
@@ -95,9 +84,6 @@
 	./wvtestrun $(MAKE) PYTHON=$(PYTHON) runtests
 
 check: test
-
-%: %.o
-	$(CC) $(CFLAGS) (LDFLAGS) -o $@ $^ $(LIBS)
 
 bup: main.py
 	rm -f $@
@@ -123,9 +109,6 @@
 	rm -f $@
 	ln -s $*-cmd.sh $@
 
-%.o: %.c
-	gcc -c -o $@ $< $(CPPFLAGS) $(CFLAGS)
-	
 # update the local 'man' and 'html' branches with pregenerated output files, for
 # people who don't have pandoc (and maybe to aid in google searches or something)
 export-docs: Documentation/all
@@ -155,10 +138,13 @@
 	git archive origin/html | (cd Documentation; tar -xvf -)
 	git archive origin/man | (cd Documentation; tar -xvf -)
 
+# tgit.py plays with permissions on lib/bup/t/pybuptest.tmp, so we should
+# ensure that we can delete the directory before doing it.
 clean: Documentation/clean
 	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll *.exe \
 		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
 		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
 		bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
 		out[12] out2[tc] tags[12] tags2[tc]
+	[ -d lib/bup/t/pybuptest.tmp ] && chmod u+rwx lib/bup/t/pybuptest.tmp || true
 	rm -rf *.tmp t/*.tmp lib/*/*/*.tmp build lib/bup/build

=== debian/changelog ===
bup (0.24b-1) unstable; urgency=low

  * New upstream version.
  * bump standards version.

 -- Jon Dowland <jmtd@debian.org>  Fri, 08 Jul 2011 09:55:48 +0100

bup (0.21-1) unstable; urgency=low

  * New upstream version. Closes: #610690.

 -- Jon Dowland <jmtd@debian.org>  Mon, 24 Jan 2011 22:47:11 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Jon Dowland <jmtd@debian.org>
 Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev, python-support,
  git (>= 1:1.7.0.4-2) | git-core
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://github.com/apenwarr/bup
 Vcs-Git: git://git.debian.org/collab-maint/bup.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/bup.git;a=shortlog;h=refs/heads/debian

## bup 0.25~git2011.11.04

=== Makefile ===
--- 
+++ 
@@ -16,10 +16,11 @@
 
 INSTALL=install
 PYTHON=python
-MANDIR=$(DESTDIR)/usr/share/man
-DOCDIR=$(DESTDIR)/usr/share/doc/bup
-BINDIR=$(DESTDIR)/usr/bin
-LIBDIR=$(DESTDIR)/usr/lib/bup
+PREFIX=/usr
+MANDIR=$(DESTDIR)$(PREFIX)/share/man
+DOCDIR=$(DESTDIR)$(PREFIX)/share/doc/bup
+BINDIR=$(DESTDIR)$(PREFIX)/bin
+LIBDIR=$(DESTDIR)$(PREFIX)/lib/bup
 install: all
 	$(INSTALL) -d $(MANDIR)/man1 $(DOCDIR) $(BINDIR) \
 		$(LIBDIR)/bup $(LIBDIR)/cmd $(LIBDIR)/tornado \
@@ -56,11 +57,17 @@
 
 %/clean:
 	$(MAKE) -C $* clean
+	
+config/config.h: config/Makefile config/configure config/configure.inc \
+		$(wildcard config/*.in)
+	cd config && make config.h
 
 lib/bup/_helpers$(SOEXT): \
+		config/config.h \
 		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
 	@rm -f $@
-	cd lib/bup && LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(PYTHON) csetup.py build
+	cd lib/bup && \
+	LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(PYTHON) csetup.py build
 	cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/
 
 .PHONY: lib/bup/_version.py
@@ -72,10 +79,15 @@
 runtests: all runtests-python runtests-cmdline
 
 runtests-python:
-	$(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py
+	$(PYTHON) wvtest.py \
+		$(wildcard t/t*.py) \
+		$(filter-out lib/bup/t/tmetadata.py,$(wildcard lib/*/t/t*.py))
+	[ -z "${TEST_META}" ] || \
+	$(PYTHON) wvtest.py lib/bup/t/tmetadata.py
 
 runtests-cmdline: all
 	t/test.sh
+	[ -z "${TEST_META}" ] || t/test-meta.sh
 
 stupid:
 	PATH=/bin:/usr/bin $(MAKE) test
@@ -138,13 +150,13 @@
 	git archive origin/html | (cd Documentation; tar -xvf -)
 	git archive origin/man | (cd Documentation; tar -xvf -)
 
-# tgit.py plays with permissions on lib/bup/t/pybuptest.tmp, so we should
-# ensure that we can delete the directory before doing it.
 clean: Documentation/clean
-	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll *.exe \
+	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
 		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
 		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
 		bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
-		out[12] out2[tc] tags[12] tags2[tc]
-	[ -d lib/bup/t/pybuptest.tmp ] && chmod u+rwx lib/bup/t/pybuptest.tmp || true
+		out[12] out2[tc] tags[12] tags2[tc] \
+		testfs.img lib/bup/t/testfs.img
 	rm -rf *.tmp t/*.tmp lib/*/*/*.tmp build lib/bup/build
+	if test -e testfs; then rmdir testfs; fi
+	if test -e lib/bup/t/testfs; then rmdir lib/bup/t/testfs; fi

=== config/Makefile ===
-include config.vars

config.h: configure configure.inc $(wildcard *.in)
	./configure

clean:
	rm -f ${CONFIGURE_FILES} ${GENERATED_FILES}
	rm -f *~ .*~

=== debian/changelog ===
bup (0.25~git2011.11.04-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Recent version of Git expects that the commit username is not empty,
    whereas bup was using GECOS field which may be empty, thus tests
    executed at build time were broken. Closes: #702769.

 -- Arnaud Fontaine <arnau@debian.org>  Mon, 18 Mar 2013 16:49:50 +0900

bup (0.25~git2011.11.04-5) unstable; urgency=low

  * Add 0.22a-1 changelog entry to this file. Remove changelog
    entry for  0.21-1 which was never uploaded.  Closes: #665650.
  * The experimental upload appears to have worked!
    Closes: #664185, #668997.

 -- Jon Dowland <jmtd@debian.org>  Fri, 25 May 2012 11:55:14 +0100

bup (0.25~git2011.11.04-4) experimental; urgency=low

  * Bump standards version.
  * Skip 'make test' on s390 to avoid FTBFS. This might
    resolve #664185.
  * Adjust two 'asserts' to be side-effect free, so that
    users could run with PYTHONOPTIMIZE adjusted. This might
    resolve #668997.

 -- Jon Dowland <jmtd@debian.org>  Thu, 24 May 2012 09:43:28 +0100

bup (0.25~git2011.11.04-3) unstable; urgency=low

  * Add two patches from Gonéri Le Bouder to fix building
    on KFreeBSD. Boy, we have a lot of build failures.
    Thanks Gonéri! Closes: #651104.

 -- Jon Dowland <jmtd@debian.org>  Wed, 11 Jan 2012 21:34:48 +0000

bup (0.25~git2011.11.04-2) unstable; urgency=low

  * Add bloom-unaligned-bufs to the series file. Oops!
    Thanks Jakub Wilk. Closes: #641488.

 -- Jon Dowland <jmtd@debian.org>  Tue, 03 Jan 2012 20:48:36 +0000

bup (0.25~git2011.11.04-1) unstable; urgency=low

  [ Teemu Ikonen ]
  * New upstream version.
  * Add a proper patch 'no-werror' for the previous NMU, fixing FTBFS
    (closes: #643060).
  * Refresh patches 'mangle-version' and 'excise-tornado' to work
    with the new upstream version.
  * rules:
    - override dh_auto_configure: Call ./configure without arguments.
    - override dh_auto_clean: Remove files generated by configure.

  [ Jon Dowland ]
  * We've merged upstream commit 8953dc8 (a couple ahead of bup-0.25-rc1)
  * Acknowledge NMU.  Thanks Julien Cristau!
  * Don't use pandoc on architectures where it's missing.
    Thanks Julien Cristau. Closes: #641637.
  * New package should fix python dependency. Closes: #649351.
  * Fix an unaligned-access problem which caused FTBFS on SPARC.
    Thanks once again Julien Cristau. Closes: #641488.

 -- Jon Dowland <jmtd@debian.org>  Mon, 05 Dec 2011 15:44:38 +0000

bup (0.24b-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Don't build with -Werror, to fix build failure (closes: #633145)

 -- Julien Cristau <jcristau@debian.org>  Sat, 20 Aug 2011 19:31:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,11 @@
 Section: admin
 Priority: extra
 Maintainer: Jon Dowland <jmtd@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), pandoc, python-dev, python-support,
+Build-Depends: debhelper (>= 7.0.50~),
+ pandoc [!ia64 !mipsel !s390 !hurd-i386],
+ python-dev, python-support,
  git (>= 1:1.7.0.4-2) | git-core
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://github.com/apenwarr/bup
 Vcs-Git: git://git.debian.org/collab-maint/bup.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/bup.git;a=shortlog;h=refs/heads/debian

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_configure:
	mv lib/bup/_version.py.pre lib/bup/_oldversion.py.pre
	cp -p debian/_version.py.pre lib/bup
	./configure

override_dh_auto_clean:
	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
	dh_auto_clean
	if test -f lib/bup/_oldversion.py.pre; then \
		mv lib/bup/_oldversion.py.pre lib/bup/_version.py.pre; \
	fi

override_dh_auto_test:
	if [ "`dpkg-architecture -qDEB_BUILD_ARCH`" != "s390" ]; then \
		dh_auto_test; \
	fi

%:
	dh $@

## bup 0.25~git20130505

=== Makefile ===
--- 
+++ 
@@ -9,6 +9,7 @@
 default: all
 
 all: bup Documentation/all
+	t/configure-sampledata --setup
 
 bup: lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds
 
@@ -57,10 +58,10 @@
 
 %/clean:
 	$(MAKE) -C $* clean
-	
+
 config/config.h: config/Makefile config/configure config/configure.inc \
 		$(wildcard config/*.in)
-	cd config && make config.h
+	cd config && $(MAKE) config.h
 
 lib/bup/_helpers$(SOEXT): \
 		config/config.h \
@@ -78,16 +79,18 @@
 
 runtests: all runtests-python runtests-cmdline
 
-runtests-python:
+runtests-python: all
 	$(PYTHON) wvtest.py \
 		$(wildcard t/t*.py) \
 		$(filter-out lib/bup/t/tmetadata.py,$(wildcard lib/*/t/t*.py))
-	[ -z "${TEST_META}" ] || \
 	$(PYTHON) wvtest.py lib/bup/t/tmetadata.py
 
 runtests-cmdline: all
+	t/test-index-check-device.sh
+	t/test-meta.sh
+	t/test-restore-single-file.sh
+	t/test-rm-between-index-and-save.sh
 	t/test.sh
-	[ -z "${TEST_META}" ] || t/test-meta.sh
 
 stupid:
 	PATH=/bin:/usr/bin $(MAKE) test
@@ -150,13 +153,22 @@
 	git archive origin/html | (cd Documentation; tar -xvf -)
 	git archive origin/man | (cd Documentation; tar -xvf -)
 
-clean: Documentation/clean
+clean: Documentation/clean config/clean
 	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
 		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
 		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
 		bup bup-* cmd/bup-* lib/bup/_version.py randomgen memtest \
 		out[12] out2[tc] tags[12] tags2[tc] \
 		testfs.img lib/bup/t/testfs.img
-	rm -rf *.tmp t/*.tmp lib/*/*/*.tmp build lib/bup/build
-	if test -e testfs; then rmdir testfs; fi
-	if test -e lib/bup/t/testfs; then rmdir lib/bup/t/testfs; fi
+	umount t/mnt/* || true
+	if test -e t/mnt; then rm -r t/mnt; fi
+        # FIXME: migrate these to t/mnt/
+	if test -e bupmeta.tmp/testfs; \
+	  then umount bupmeta.tmp/testfs || true; fi
+	if test -e lib/bup/t/testfs; \
+	  then umount lib/bup/t/testfs || true; fi
+	if test -e bupmeta.tmp/testfs-limited; \
+	  then umount bupmeta.tmp/testfs-limited || true; fi
+	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
+	if test -e t/tmp; then rm -r t/tmp; fi
+	t/configure-sampledata --clean

=== debian/changelog ===
bup (0.25~git20130505-1) unstable; urgency=low

  * Upload to unstable.
  * Merge upstream commit 6cf3688.
  * Push Debian source package changes to git.debian.org; closes: #704908.
  * Don't build docs on mips; closes: #704910.

 -- Robert S. Edmonds <edmonds@debian.org>  Mon, 06 May 2013 15:35:00 -0400

bup (0.25~git20130303-1) experimental; urgency=low

  * New maintainer; closes: #699163.
  * Merge upstream commit 7e9005e.
  * Convert from python-support to dh_python2.

 -- Robert S. Edmonds <edmonds@debian.org>  Sun, 03 Mar 2013 19:43:36 -0500

bup (0.25~git2011.11.04-6) experimental; urgency=low

  * Add --parallel to dh* calls to support parallel building.
  * Depend upon python-pyxattr and python-pylibacl so that "bup
    meta" works. Thanks Sascha Silbe. Closes: #692009.

 -- Jon Dowland <jmtd@debian.org>  Tue, 06 Nov 2012 22:50:59 +0000

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,15 @@
 Source: bup
 Section: admin
 Priority: extra
-Maintainer: Jon Dowland <jmtd@debian.org>
+Maintainer: Robert S. Edmonds <edmonds@debian.org>
 Build-Depends: debhelper (>= 7.0.50~),
- pandoc [!ia64 !mipsel !s390 !hurd-i386],
- python-dev, python-support,
- git (>= 1:1.7.0.4-2) | git-core
+ pandoc [!ia64 !mips !mipsel !s390 !hurd-i386],
+ python-dev (>= 2.6.6-3~),
+ python-pyxattr, python-pylibacl,
+ git (>= 1:1.7.0.4-2) | git-core,
+ rsync
 Standards-Version: 3.9.3
-Homepage: http://github.com/apenwarr/bup
+Homepage: https://github.com/bup/bup
 Vcs-Git: git://git.debian.org/collab-maint/bup.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/bup.git;a=shortlog;h=refs/heads/debian

=== debian/rules ===
--- 
+++ 
@@ -7,15 +7,15 @@
 
 override_dh_auto_clean:
 	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
-	dh_auto_clean
+	dh_auto_clean --parallel
 	if test -f lib/bup/_oldversion.py.pre; then \
 		mv lib/bup/_oldversion.py.pre lib/bup/_version.py.pre; \
 	fi
 
 override_dh_auto_test:
 	if [ "`dpkg-architecture -qDEB_BUILD_ARCH`" != "s390" ]; then \
-		dh_auto_test; \
+		dh_auto_test --parallel; \
 	fi
 
 %:
-	dh $@
+	dh $@ --with python2 --parallel

## bup 0.25

=== Makefile ===
--- 
+++ 
@@ -1,9 +1,15 @@
 OS:=$(shell uname | sed 's/[-_].*//')
-CFLAGS:=-Wall -O2 -Werror $(PYINCLUDE)
+CFLAGS := -Wall -O2 -Werror $(PYINCLUDE) $(CFLAGS)
 SOEXT:=.so
 
 ifeq ($(OS),CYGWIN)
   SOEXT:=.dll
+endif
+
+ifdef TMPDIR
+  test_tmp := $(TMPDIR)
+else
+  test_tmp := $(CURDIR)/t/tmp
 endif
 
 default: all
@@ -34,23 +40,23 @@
 	  $(INSTALL) -m 0644 \
 		Documentation/*.html \
 		$(DOCDIR)
-	$(INSTALL) -m 0755 bup $(BINDIR)
-	$(INSTALL) -m 0755 \
+	$(INSTALL) -pm 0755 bup $(BINDIR)
+	$(INSTALL) -pm 0755 \
 		cmd/bup-* \
 		$(LIBDIR)/cmd
-	$(INSTALL) -m 0644 \
+	$(INSTALL) -pm 0644 \
 		lib/bup/*.py \
 		$(LIBDIR)/bup
-	$(INSTALL) -m 0755 \
+	$(INSTALL) -pm 0755 \
 		lib/bup/*$(SOEXT) \
 		$(LIBDIR)/bup
-	$(INSTALL) -m 0644 \
+	$(INSTALL) -pm 0644 \
 		lib/tornado/*.py \
 		$(LIBDIR)/tornado
-	$(INSTALL) -m 0644 \
+	$(INSTALL) -pm 0644 \
 		lib/web/static/* \
 		$(LIBDIR)/web/static/
-	$(INSTALL) -m 0644 \
+	$(INSTALL) -pm 0644 \
 		lib/web/*.html \
 		$(LIBDIR)/web/
 %/all:
@@ -80,17 +86,20 @@
 runtests: all runtests-python runtests-cmdline
 
 runtests-python: all
-	$(PYTHON) wvtest.py \
-		$(wildcard t/t*.py) \
-		$(filter-out lib/bup/t/tmetadata.py,$(wildcard lib/*/t/t*.py))
-	$(PYTHON) wvtest.py lib/bup/t/tmetadata.py
+	test -e t/tmp || mkdir t/tmp
+	TMPDIR="$(test_tmp)" $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py
 
 runtests-cmdline: all
-	t/test-index-check-device.sh
-	t/test-meta.sh
-	t/test-restore-single-file.sh
-	t/test-rm-between-index-and-save.sh
-	t/test.sh
+	test -e t/tmp || mkdir t/tmp
+	TMPDIR="$(test_tmp)" t/test-cat-file.sh
+	TMPDIR="$(test_tmp)" t/test-index-check-device.sh
+	TMPDIR="$(test_tmp)" t/test-meta.sh
+	TMPDIR="$(test_tmp)" t/test-restore-map-owner.sh
+	TMPDIR="$(test_tmp)" t/test-restore-single-file.sh
+	TMPDIR="$(test_tmp)" t/test-rm-between-index-and-save.sh
+	TMPDIR="$(test_tmp)" t/test-command-without-init-fails.sh
+	TMPDIR="$(test_tmp)" t/test-redundant-saves.sh
+	TMPDIR="$(test_tmp)" t/test.sh
 
 stupid:
 	PATH=/bin:/usr/bin $(MAKE) test
@@ -170,5 +179,5 @@
 	if test -e bupmeta.tmp/testfs-limited; \
 	  then umount bupmeta.tmp/testfs-limited || true; fi
 	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
-	if test -e t/tmp; then rm -r t/tmp; fi
+	if test -e t/tmp; then t/force-delete t/tmp; fi
 	t/configure-sampledata --clean

=== Documentation/Makefile ===
--- 
+++ 
@@ -14,14 +14,14 @@
 
 all: man html
 
-man: $(patsubst %.md,%,$(wildcard *.md))
+man: $(patsubst %.md,%.1,$(wildcard *.md))
 
-html: $(patsubst %.1.md,%.html,$(wildcard *.md))
+html: $(patsubst %.md,%.html,$(wildcard *.md))
 
-%: %.md.tmp Makefile
+%.1: %.md.tmp Makefile
 	$(PANDOC) -s -r markdown -w man -o $@ $<
 	
-%.html: %.1.md.tmp Makefile
+%.html: %.md.tmp Makefile
 	$(PANDOC) -s -r markdown -w html -o $@ $<
 	
 .PRECIOUS: %.md.tmp

=== debian/changelog ===
bup (0.25-1) unstable; urgency=medium

  * New upstream release.

 -- Robert S. Edmonds <edmonds@debian.org>  Mon, 16 Dec 2013 11:55:58 -0500

bup (0.25~rc5-1) unstable; urgency=medium

  * New upstream release.

 -- Robert S. Edmonds <edmonds@debian.org>  Tue, 10 Dec 2013 14:42:47 -0500

bup (0.25~rc4-1) unstable; urgency=low

  * New upstream release.
  * Increase debhelper compat level to 9.
  * Re-enable python-pylibacl on non-Linux architectures;
    tentatively closes: #726727.

 -- Robert S. Edmonds <edmonds@debian.org>  Fri, 15 Nov 2013 14:31:34 -0500

bup (0.25~rc3-1) unstable; urgency=low

  * New upstream release.

 -- Robert S. Edmonds <edmonds@debian.org>  Tue, 24 Sep 2013 19:08:12 -0400

bup (0.25~rc2-3) unstable; urgency=low

  * Build-Depend and Depend on python-pylibacl and python-pyxattr only on
    linux-any.
  * Build-Depend and Depend on par2 only on !hurd-i386.
  * Add Build-Depends-Indep on pandoc-data due to pandoc/pandoc-data binary
    package split.

 -- Robert S. Edmonds <edmonds@debian.org>  Sun, 01 Sep 2013 14:40:26 -0400

bup (0.25~rc2-2) unstable; urgency=low

  * Fold bup-fuse and bup-web back into the main 'bup' package at the
    suggestion of the Debian FTP Masters.
  * Demote the Depends on python-fuse (for 'bup fuse') and python-tornado
    (for 'bup web') to Recommends, since these scripts have import guards
    and will print a proper error message if these packages aren't installed.

 -- Robert S. Edmonds <edmonds@debian.org>  Sat, 10 Aug 2013 17:13:36 -0400

bup (0.25~rc2-1) unstable; urgency=low

  * New upstream release.
  * New binary packages:
    - bup-doc
    - bup-fuse
    - bup-web
  * Add dependency on python-pylibacl, python-pyxattr, in order to backup
    file metadata.
  * Promote dependency on par2 from Recommends to Depends.

 -- Robert S. Edmonds <edmonds@debian.org>  Thu, 08 Aug 2013 22:00:57 -0400

=== debian/control ===
Source: bup
Section: admin
Priority: extra
Maintainer: Robert S. Edmonds <edmonds@debian.org>
Build-Depends: debhelper (>= 9~), dctrl-tools,
 python-dev (>= 2.6.6-3~),
 python-pylibacl,
 python-pyxattr [linux-any],
 git,
 par2 [!hurd-i386],
 rsync
Build-Depends-Indep: pandoc (>= 1.11.1-4~), pandoc-data (>= 1.11.1-4~)
Standards-Version: 3.9.4
Homepage: https://github.com/bup/bup
Vcs-Git: git://anonscm.debian.org/collab-maint/bup.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/bup.git;a=shortlog;h=refs/heads/debian

Package: bup
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, python,
 git, par2 [!hurd-i386], python-pylibacl, python-pyxattr [linux-any]
Recommends: bup-doc, python-fuse, python-tornado
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

Package: bup-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: bup (<< 0.25~rc2-2~)
Replaces: bup (<< 0.25~rc2-2~)
Description: highly efficient file backup system based on git (documentation)
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_configure:
	./configure

override_dh_auto_build-indep:
	$(MAKE) Documentation/all

override_dh_install:
	rm -rf debian/tmp/usr/lib/bup/tornado
	dh_install

override_dh_auto_clean:
	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
	dh_auto_clean

## bup 0.27

=== Makefile ===

sampledata_rev := $(shell t/configure-sampledata --revision)
current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)

OS:=$(shell uname | sed 's/[-_].*//')
CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
SOEXT:=.so

ifeq ($(OS),CYGWIN)
  SOEXT:=.dll
endif

ifdef TMPDIR
  test_tmp := $(TMPDIR)
else
  test_tmp := $(CURDIR)/t/tmp
endif

initial_setup := $(shell ./configure-version --update)
bup_deps := bup lib/bup/_version.py lib/bup/_helpers$(SOEXT) cmds

all: $(bup_deps) Documentation/all $(current_sampledata)

bup:
	ln -s main.py bup

Documentation/all: $(bup_deps)

$(current_sampledata):
	t/configure-sampledata --setup

INSTALL=install
PYTHON=python
PREFIX=/usr
MANDIR=$(DESTDIR)$(PREFIX)/share/man
DOCDIR=$(DESTDIR)$(PREFIX)/share/doc/bup
BINDIR=$(DESTDIR)$(PREFIX)/bin
LIBDIR=$(DESTDIR)$(PREFIX)/lib/bup
install: all
	$(INSTALL) -d $(MANDIR)/man1 $(DOCDIR) $(BINDIR) \
		$(LIBDIR)/bup $(LIBDIR)/cmd \
		$(LIBDIR)/web $(LIBDIR)/web/static
	[ ! -e Documentation/.docs-available ] || \
	  $(INSTALL) -m 0644 \
		Documentation/*.1 \
		$(MANDIR)/man1
	[ ! -e Documentation/.docs-available ] || \
	  $(INSTALL) -m 0644 \
		Documentation/*.html \
		$(DOCDIR)
	$(INSTALL) -pm 0755 bup $(BINDIR)
	$(INSTALL) -pm 0755 \
		cmd/bup-* \
		$(LIBDIR)/cmd
	$(INSTALL) -pm 0644 \
		lib/bup/*.py \
		$(LIBDIR)/bup
	$(INSTALL) -pm 0755 \
		lib/bup/*$(SOEXT) \
		$(LIBDIR)/bup
	$(INSTALL) -pm 0644 \
		lib/web/static/* \
		$(LIBDIR)/web/static/
	$(INSTALL) -pm 0644 \
		lib/web/*.html \
		$(LIBDIR)/web/
%/all:
	$(MAKE) -C $* all

%/clean:
	$(MAKE) -C $* clean

config/config.h: config/Makefile config/configure config/configure.inc \
		$(wildcard config/*.in)
	cd config && $(MAKE) config.h

lib/bup/_helpers$(SOEXT): \
		config/config.h \
		lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
	@rm -f $@
	cd lib/bup && \
	LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" $(PYTHON) csetup.py build
	cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/

lib/bup/_version.py:
	@echo "Something has gone wrong; $@ should already exist."
	@echo 'Check "./configure-version --update"'
	@false

t/tmp:
	mkdir t/tmp

runtests: runtests-python runtests-cmdline

runtests-python: all t/tmp
	TMPDIR="$(test_tmp)" $(PYTHON) wvtest.py t/t*.py lib/*/t/t*.py

cmdline_tests := \
  t/test-fuse.sh \
  t/test-drecurse.sh \
  t/test-cat-file.sh \
  t/test-compression.sh \
  t/test-fsck.sh \
  t/test-index-clear.sh \
  t/test-index-check-device.sh \
  t/test-ls.sh \
  t/test-meta.sh \
  t/test-on.sh \
  t/test-restore-map-owner.sh \
  t/test-restore-single-file.sh \
  t/test-rm-between-index-and-save.sh \
  t/test-sparse-files.sh \
  t/test-command-without-init-fails.sh \
  t/test-redundant-saves.sh \
  t/test-save-creates-no-unrefs.sh \
  t/test-save-restore-excludes.sh \
  t/test-save-strip-graft.sh \
  t/test-import-duplicity.sh \
  t/test-import-rdiff-backup.sh \
  t/test-xdev.sh \
  t/test.sh

# For parallel runs.
tmp-target-run-test%: all t/tmp
	TMPDIR="$(test_tmp)" t/test$*

runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))

stupid:
	PATH=/bin:/usr/bin $(MAKE) test

test: all
	./wvtestrun $(MAKE) PYTHON=$(PYTHON) runtests-python runtests-cmdline

check: test

cmds: \
    $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
    $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))

cmd/bup-%: cmd/%-cmd.py
	rm -f $@
	ln -s $*-cmd.py $@

cmd/bup-%: cmd/%-cmd.sh
	rm -f $@
	ln -s $*-cmd.sh $@

# update the local 'man' and 'html' branches with pregenerated output files, for
# people who don't have pandoc (and maybe to aid in google searches or something)
export-docs: Documentation/all
	git update-ref refs/heads/man origin/man '' 2>/dev/null || true
	git update-ref refs/heads/html origin/html '' 2>/dev/null || true
	GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
	rm -f $${GIT_INDEX_FILE} && \
	git add -f Documentation/*.1 && \
	git update-ref refs/heads/man \
		$$(echo "Autogenerated man pages for $$(git describe --always)" \
		    | git commit-tree $$(git write-tree --prefix=Documentation) \
				-p refs/heads/man) && \
	rm -f $${GIT_INDEX_FILE} && \
	git add -f Documentation/*.html && \
	git update-ref refs/heads/html \
		$$(echo "Autogenerated html pages for $$(git describe --always)" \
		    | git commit-tree $$(git write-tree --prefix=Documentation) \
				-p refs/heads/html)

# push the pregenerated doc files to origin/man and origin/html
push-docs: export-docs
	git push origin man html

# import pregenerated doc files from origin/man and origin/html, in case you
# don't have pandoc but still want to be able to install the docs.
import-docs: Documentation/clean
	git archive origin/html | (cd Documentation; tar -xvf -)
	git archive origin/man | (cd Documentation; tar -xvf -)

clean: Documentation/clean config/clean
	rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
		.*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
		*.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
		bup bup-* cmd/bup-* \
		randomgen memtest \
		testfs.img lib/bup/t/testfs.img
	if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
	if test -e t/mnt; then rm -r t/mnt; fi
	if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
        # FIXME: migrate these to t/mnt/
	if test -e lib/bup/t/testfs; \
	  then umount lib/bup/t/testfs || true; fi
	rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
	if test -e t/tmp; then t/force-delete t/tmp; fi
	./configure-version --clean
	t/configure-sampledata --clean

=== config/Makefile ===
-include config.vars

config.h: configure configure.inc $(wildcard *.in)
	MAKE=${MAKE} ./configure

clean:
	rm -f ${CONFIGURE_FILES} ${CONFIGURE_DETRITUS} ${GENERATED_FILES}
	rm -f *~ .*~

=== debian/changelog ===
bup (0.27-2) unstable; urgency=medium

  [ Chris Lamb ]
  * debian/gen_version_py.sh: Make the build reproducible (Closes: #792673)

  [ Robert Edmonds ]
  * debian/gbp.conf: Add [dch] section
  * debian/gbp.conf: Move 'debian-branch' setting into [DEFAULT] section
  * debian/: Run "wrap-and-sort -sbt"
  * debian/control: Update Vcs-Browser
  * debian/control: Add dh-python to Build-Depends

 -- Robert Edmonds <edmonds@debian.org>  Sat, 19 Dec 2015 15:16:57 -0500

bup (0.27-1) unstable; urgency=medium

  * New upstream release. (Closes: #787098)
  * Cherry-pick upstream commit cd09571851cd2c1e6e9c7b8195c0bc72ac31ae6a
    ("Update definition lists for pandoc 1.13").
  * Upload to unstable.

 -- Robert Edmonds <edmonds@debian.org>  Sat, 13 Jun 2015 17:11:02 -0400

bup (0.27~rc4-1) experimental; urgency=medium

  * New upstream release.

 -- Robert Edmonds <edmonds@debian.org>  Sun, 29 Mar 2015 21:12:30 -0400

bup (0.27~rc3-1) experimental; urgency=medium

  * New upstream release.

 -- Robert Edmonds <edmonds@debian.org>  Sat, 14 Mar 2015 15:41:36 -0400

bup (0.26-1) unstable; urgency=medium

  * New upstream release.

 -- Robert S. Edmonds <edmonds@debian.org>  Sat, 23 Aug 2014 08:26:03 -0700

bup (0.26~rc1-1) experimental; urgency=medium

  * New upstream release.

 -- Robert S. Edmonds <edmonds@debian.org>  Wed, 28 May 2014 18:57:12 -0400

=== debian/control ===
Source: bup
Section: admin
Priority: extra
Maintainer: Robert Edmonds <edmonds@debian.org>
Build-Depends:
 dctrl-tools,
 debhelper (>= 9~),
 dh-python,
 git,
 par2 [!hurd-i386],
 python-dev (>= 2.6.6-3~),
 python-pylibacl,
 python-pyxattr [linux-any],
 rsync,
Build-Depends-Indep: pandoc (>= 1.11.1-4~), pandoc-data (>= 1.11.1-4~)
Standards-Version: 3.9.6
Homepage: https://github.com/bup/bup
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/bup.git
Vcs-Git: git://anonscm.debian.org/collab-maint/bup.git

Package: bup
Architecture: any
Depends:
 git,
 par2 [!hurd-i386],
 python,
 python-pylibacl,
 python-pyxattr [linux-any],
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Recommends: bup-doc, python-fuse, python-tornado
Description: highly efficient file backup system based on git
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.

Package: bup-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Breaks: bup (<< 0.25~rc2-2~)
Replaces: bup (<< 0.25~rc2-2~)
Description: highly efficient file backup system based on git (documentation)
 bup is a backup tool which stores the backups in a system based around
 the packfile format from git.
 .
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_configure:
	./configure

override_dh_auto_build-indep:
	$(MAKE) Documentation/all

override_dh_auto_clean:
	-rm config/config.cmd config/config.h config/config.log config/config.mak config/config.md config/config.sub config/config.vars
	dh_auto_clean

## bup 0.27.1

=== debian/changelog ===
bup (0.27.1-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- Robert Edmonds <edmonds@debian.org>  Wed, 18 May 2016 23:00:17 -0400

bup (0.27.1~rc2-2) experimental; urgency=medium

  * Cherry pick 'test_server_split_with_indexes: close packwriter' from
    upstream master.

 -- Robert Edmonds <edmonds@debian.org>  Sun, 15 May 2016 13:39:26 -0400

bup (0.27.1~rc2-1) experimental; urgency=medium

  * New upstream release.

 -- Robert Edmonds <edmonds@debian.org>  Sat, 14 May 2016 18:48:46 -0400
